$(document).ready(function() {

    var path = window.location.pathname.toString().split('/');
    path[path.length - 1] = 'ajax.php';
    if (typeof(window.location.origin) == 'undefined') {
        window.location.origin = window.location.protocol + '//' + window.location.host;
    }
    window.ajaxurl = window.location.origin + path.join('/');window.modulename = window.location.search.split(/\?|&/)[1].split('=')[1];
    window.wcode = null;
    var s,
        ModuleIUB24 = {

            /**
             * Настройки модуля
             */
            settings: {
                protocol: '.protocol',
                appContent: $('#templates-informunity-b24').html(),
                navContent: $('#templates-informunity-b24-nav').html(),
                accessCode: $('.tab-content').find('input[name="access_code"]'),
                clearCacheID: $('#cache_ids'),
                buttons: {
                    update: '#update',
                    back: '#return',
                    submit: '#submit',
                    register: '#register',
                    cache: '#clear_cache',
                    handlers_link: '#handlers_link',
                    recording_mp3: '#mp3',
                    recording_stereo: '#stereo',
                    recordings: "input[name=recordings]",
                    download_log: "input[data-bind='download_log']"
                }
            },

            /**
             * Инициализация модуля
             */
            init: function() {

                s = this;
                this.__checkActives();
                this.bindUIActions();

                this.showOrHideSettingTab();
                this.chooseActiveTab();

                if ($(s.settings.buttons.recording_mp3+":checked").length || $(s.settings.buttons.recording_stereo+":checked").length) {
                    s.hideYesButton();
                }

                this.checkAviablesSites([
                    'oauth.bitrix.info',
                    'license.informunity.ru'
                ]);
            },

            /**
             * События работы модуля
             */
            bindUIActions: function() {
                var self = this;

                $(document.body).on('click', '[data-bind="iu-event-delete"]', function(){
                    var btn = this;
                    var eventCode = $(this).attr('data-code');
                    var hndl = $(this).attr('data-handler');

                    var removeEvent = self.removeEvent(eventCode, hndl);
                    removeEvent.then(function(r){
                        $(btn).closest('tr').remove();
                    });
                });

                $(document.body).on('click', '[data-bind="show-events-list"]', function(){

                    var eventCode = $(this).attr('data-code');
                    var buttons = [];
                    buttons['Close'] = iub24.lang[currentLocale]['Close'];
                    var buttonArray = {};
                    buttonArray[buttons['Close']] = function() {
                        $(this).dialog('close');
                    };

                    $("#list_b24_events_"+eventCode).dialog({
                        resizable: false,
                        height: "auto",
                        width: "auto",
                        modal: true,
                        buttons: buttonArray
                    });
                });

                $(document.body).on('click', '[data-bind="save_softphone_port"]', function(){
                    var saved = self.saveCompabilitySoftphone($('#externalWSSPort').val());
                    saved.then(function(data) {
                        console.log('saveCompabilitySoftphone', data);
                        if(typeof data.error != 'undefined') {
                            fpbxToast(data['error'],'','error');
                            $('#page_body .container-fluid').before(data.message);
                        } else {
                            fpbxToast(data.saved,'','success');
                        }
                        
                    }, function(err){
                        console.error(err);
                        fpbxToast('Server error','','error');
                    });
                    
                    //$('#check_softphone_compability').dialog('close');
                });

                $(document.body).on('click', '[data-bind="check_softphone_comp"]', function(){
                    var buttons = [];
                    
                    buttons['Close'] = iub24.lang[currentLocale]['Close'];

                    var buttonArray = {};
                    /*buttonArray[buttons['Submit']] = function() {
                        self.saveCompabilitySoftphone($('#externalWSSPort').val());
                        $(this).dialog("close");
                    };*/
                    buttonArray[buttons['Close']] = function() {
                        $(this).dialog('close');
                    };

                    var promise = $.ajax({
                        url: window.ajaxurl,
                        type: "POST",
                        data: {
                            command: 'getSoftphoneData',
                            module: window.modulename
                        }
                    });
                    promise.then(function(data) {
                        console.log('getSoftphoneData', data);
                        data['miniHttpServer'] ? $('#miniHttpsServYes').prop('checked', true) : $('#miniHttpsServYes').prop('disabled', true);
                        !data['miniHttpServer'] ? $('#miniHttpsServNo').prop('checked', true) : $('#miniHttpsServNo').attr('disabled', true);

                        data['tlsMiniServ'] ? $('#TLSminiServYes').prop('checked', true) : $('#TLSminiServYes').prop('disabled', true);
                        !data['tlsMiniServ'] ? $('#TLSminiServNo').prop('checked', true) : $('#TLSminiServNo').attr('disabled', true);

                        data['configureSertif'] ? $('#configSertificateYes').prop('checked', true) : $('#configSertificateYes').prop('disabled', true);
                        !data['configureSertif'] ? $('#configSertificateNo').prop('checked', true) : $('#configSertificateNo').attr('disabled', true);

                        if(data['externalWssPort'].length)
                            $('#externalWSSPort').val(data['externalWssPort']);

                        $("#check_softphone_compability").dialog({
                            resizable: false,
                            height: "auto",
                            width: 800,
                            modal: true,
                            buttons: buttonArray
                        });
                        
                    },function(err){
                        console.error(err);
                    });

                    
                });

                $(document.body).on('change', s.settings.protocol, function() {
                    s.__setPort(this);
                });

                $("li").on('click', function(e) {
                    window.location.hash = $(this).attr('data-name');
                });

                $(document.body).on('click', s.settings.buttons.update, function(e) {
                    s.update();
                });

                $('body').on('click', s.settings.buttons.back, function() {
                    s.back();
                });

                $(document.body).on('click', s.settings.buttons.submit, function(e) {
                    console.log('submit');
                    e.preventDefault();
                    s.submitUpdate();
                });

                $(document.body).on('click', s.settings.buttons.register, function(e) {
                    console.log('register');
                    e.preventDefault();
                    s.register();
                });

                $(document.body).on('click', s.settings.buttons.cache, function(e) {
                    s.clearCache();
                });
                $(document.body).on('click', s.settings.buttons.handlers_link, function(e) {
                    s.gotoHandlersLink();
                });
                $(document.body).on('change', s.settings.buttons.recordings, function() {
                    console.log($(this).val());
                    if ($(this).val() == 'mp3' || $(this).val() == 'stereo') {
                        s.hideYesButton();
                    } else {
                        s.showYesButton();
                    }
                });

                $(document.body).on('change', '#advanced_settings input[name="determine_region"]', function() {

                    s.determineRegion($(this).val());
                });

                $(document.body).on('click', s.settings.buttons.download_log, function() {
                    var fileLink = $('select[name="log-files"]').find(':selected').attr("data-link");
                    console.log("fileLink", fileLink);
                    window.location.href = "ajax.php?module=informunity_bitrix24&command=get_record&record=" + fileLink + "&zip=y";
                });

                s.settings.clearCacheID
                    .focusout(function() {
                        if (!s.checkClearCacheID()) { fpbxToast('Must be positive number', 'Cache ID', 'error'); }
                    });

            },

            /**
             * Получаем заполненный урл портала b24
             */
            getClientServerWhenRegister: function() {
                return $('select[name="portal_protocol"]').val() + "://" + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val();
            },

            saveCompabilitySoftphone: function(port) {
                var promise = $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'saveSoftphonePort',
                        module: window.modulename,
                        externalWSSPort: port
                    }
                });

                return promise;
            },

            /**
             * проверяем на доступность сайты
             * для дальнейшей работы
             * @param {*} urls 
             */
            checkAviablesSites: function(urls) {
                
                var promise = $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'checkAviableSite',
                        module: window.modulename,
                        url: urls[0]
                    }
                });
                promise.then(function(data) {
                    console.log('Second', data);
                    if(data.message != 'unknown') {
                        $('#page_body .container-fluid').before(data.message);
                    }
                    return $.ajax({
                        url: window.ajaxurl,
                        type: "POST",
                        data: {
                            command: 'checkAviableSite',
                            module: window.modulename,
                            url: urls[1]
                        }
                    });
                }).then(function(data){
                    if(data.message != 'unknown') {
                        $('#page_body .container-fluid').before(data.message);
                    }
                    console.log('Third', data);
                },function(err){
                    console.error(err);
                });
                console.log('First');
                
            },

            showOrHideSettingTab: function() {
                $('li[data-name=advanced_settings]').show();
                if ($('label[for=activatedyes]').length) {
                    //$('li[data-name=advanced_settings]').hide();
                    $('#extensions_count').closest('.element-container').hide();
                    $('#status_pay_b24').closest('.element-container').hide();
                    $('#active_before').closest('.element-container').hide();
                }
            },
            showYesButton: function() {
                $("#label_yes").show();
            },
            hideYesButton: function() {
                $("#label_yes").hide();
                $("#no").attr("checked","checked");
            },
            chooseActiveTab: function() {
                if (window.location.hash.length) {
                    $('li.active').removeClass('active');
                    $('.tab-pane.active').removeClass('active');
                    $('.tab-pane' + window.location.hash).addClass('active');
                    $('li[data-name="' + window.location.hash.replace('#', '') + '"]').addClass("active");
                }
            },

            checkClearCacheID: function() {
                return s.settings.clearCacheID.val() > -1 ? true : false;
            },
            /**
             * Переход на вкладку callback_handlers
             */
            gotoHandlersLink: function() {
                $('li.active').removeClass('active');
                $('li[data-name=callback_handlers]').addClass('active');
            },
            /**
             * Очистка кеша ASTDB
             */
            clearCache: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'clear',
                        module: window.modulename
                    },
                    success: function(data) {
                        console.log(data['message']);
                        fpbxToast('Complete', 'Cache Clear', 'success');
                    },
                });
            },
            /**
             * Сопоставление протокола - порту
             * @param select указатель на текущий select, обьект dom html
             * @private
             */
            __setPort: function(select) {
                console.log('setPort', $(select).val());
                var port_no = '';
                switch (($(select).val())) {
                    case 'http':
                        port_no = '80';
                        break;
                    case 'https':
                        port_no = '443';
                        break;
                    default:
                        port_no = '443';
                }
                $(select).closest('.row').find('.port').attr('value', port_no);
            },

            update: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'update',
                        module: window.modulename
                    },
                    success: function(data) {
                        console.log(data['message']);
                        window.location.href = '?display=modules';
                        //todo нужно чтоб автоматически выбиралась кнопка обновить. Аналог кгнопки обновить все.
                        $('input[name="moduleaction[informunity_bitrix24]"]').attr('checked', "CHECKED");
                    },
                });
            },

            /**
             * Кнопка возврата
             */
            back: function() {
                window.location.reload();
            },

            /**
             * Регистрация
             */
            register: function() {
                var self = this;
                console.log('work register');

                //#JS_2
                if (s.__checkInvalid()) {
                    console.log('checked');
                        s.__submitData();
                    if ($('.tab-content').find('#access_code').val()) {
                        fpbxToast('Processing', '', 'info');
                        s.__lockRegisterButton();
                        s.__newRegister();
                        window.wcode.close();
                    } else {
                        /* TODO refactor this */

                        $.ajax({
                            url: window.ajaxurl,
                            type: "POST",
                            data: {
                                command: 'setCredentials',
                                module: window.modulename,
                                client_server: $('select[name="portal_protocol"]').val() + "://" + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val(),
                                ext_address: $('select[name="fpbx_protocol"]').val() + "://" + $('input[name="ext_address"]').val() + ':' + $('input[name="ext_address_port"]').val(),
                                timeout: $('[name="timeout_request"]').val(),//self.getDestination() || ''
        
                            },
                            success: function(data) {
                                console.log(data);
                                if(typeof data['app'] != "undefined" && data['app'].length) {
                                    $('.app_id').attr('value', data['app']);

                                    self.openRegisterWindow();
                                    $('#submit').removeAttr('disabled');
                                    $('li[data-name="advanced_settings"]').css('display', 'none');
                                    $('li[data-name="settings"]').css('display', 'none');
                                    $('li[data-name="inbound_destinations"]').css('display', 'none');
                                    $('li[data-name="lines_tab"]').css('display', 'none');
                                    $('li[data-name="outbound_routes"]').css('display', 'none');
                                    $('li[data-name="callback_handlers"]').css('display', 'none');
                                    $('li[data-name="tasks"]').css('display', 'none');
                                    $('.tab-panr.active').css('display', 'none');

                                    $('.nav-tabs').find('li[data-name=advanced_ver]').remove();
                                    $('.nav-tabs').append(s.settings.navContent);

                                    $('#return').show();

                                    $('.tab-content').find('#advanced_ver').remove();
                                    $('.tab-content').append(s.settings.appContent);
                                    $('li.active').removeClass('active');
                                    $('.tab-pane.active').removeClass('active');
                                    $('.tab-pane#advanced_ver').addClass('active');
                                    $('li[data-name="advanced_ver"]').addClass("active");
                                } else {
                                    fpbxToast(data['error'], '', 'info');
                                }
                                
                             },
                        });

                        
                    }

                }
                //#END_JS_2
            },

            submitUpdate: function() {
                console.log('work submit');
                if (s.__checkInvalid()) {
                    console.log('checked');
                    fpbxToast('Processing', '', 'info');
                    s.__lockRegisterButton();
                    s.__submitData();
                    s.__updateRegister();
                }
            },

            /**
             * Получаем destination route из селектов
             * в настройках
             * @returns {*}
             */
            getDestinationForm: function($form) {
                var destination = null;

                var firstSelect = $form.find('select.destdropdown').val();
                var destination = $form.find('select[name="'+firstSelect+'0"]').val();

                return destination;
            },

            /**
             * Получаем destination route из селектов
             * в настройках
             * @returns {*}
             */
            getDestination: function() {
                var destination = $('select[name=dest_inbound_b24]').val();

                return destination;
            },
            __submitData: function() {
                console.log('save priary');
                var self = this;
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'submit',
                        module: window.modulename,
                        access_code: $('.tab-content').find('#access_code').val(),
                        client_server: $('select[name="portal_protocol"]').val() + "://" + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val(),
                        ext_address: $('select[name="fpbx_protocol"]').val() + "://" + $('input[name="ext_address"]').val() + ':' + $('input[name="ext_address_port"]').val(),
                        timeout: $('[name="timeout_request"]').val(),//self.getDestination() || ''
                        wssport: $('[name="wssport"]').val(),

                    },
                    success: function(data) {
                        console.log(data);
                    },
                });
            },
            __updateRegister: function() {
                var self = this;
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'submit',
                        module: window.modulename,
                        call_back_dest: self.getDestinationForm($('#iu_main_form')) || '',
                        ctc_autoanswer: $('[name="ctc_autoanswer"]:checked').val(),
                        recordings: $('[name="recordings"]:checked').val(),
                        links: $('[name="links"]:checked').val(),
                    },
                    success: function(data) {
                        console.log(data);
                        if (data['message'] == 'n') {
                            s.register();
                        } else if (data['message'] != 'unknown' && data['message'] != 'n') {
                            fpbxToast('Error codes:' + data['message'], 'Wrong registration', 'error');
                            /*setTimeout(function() {
                                document.location.reload();
                            }, 5000);*/
                        } else {
                            document.location.reload();
                        }
                    },
                });
            },
            __newRegister: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'register',
                        module: window.modulename,
                        client_server: $('select[name="portal_protocol"]').val() + "://" + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val(),
                        ext_address: $('select[name="fpbx_protocol"]').val() + "://" + $('input[name="ext_address"]').val() + ':' + $('input[name="ext_address_port"]').val(),
                        license: $('.license').attr('value'),
                        // create_lead: $('select[name=create_lead]').val(),
                        access_code: $('.tab-content').find('input[name="access_code"]').val()
                    },
                    success: function(data) {
                        console.log('data', data);
                        if (data['message'].length && data['message'] != 'unknown' && data['message'] != 'n') {
                            fpbxToast(data['message'], 'Register error', 'error');
                        } else {
                            document.location.reload();
                        }

                    },
                });

            },

            openRegisterWindow: function() {
                window.wcode = window.open($('select[name="portal_protocol"]').val() + '://' + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val() + '/oauth/authorize/?client_id=' + $('.app_id').attr('value'), 'Auth in Bitrix', "menubar=no, left=700, toolbar=no ,width=600, height=700");
                if (window.wcode) {
                    //Browser has allowed it to be opened
                } else {
                    //Browser has blocked it
                    alert('Please allow pop-up windows for this web-site');
                }
            },
            /**
             * Проверка на обязательные поля формы
             * @returns {boolean}
             * @private
             */
            __checkInvalid: function() {
                //#JS_1
                var req = true;
                $('.tab-content .fields_are_required').each(function() {
                    if ($(this).val() === "") {
                        console.log('empty');
                        warnInvalid($(this));
                        req = false;
                    }
                });

                var fpbxValid = true;
                var b24Valid = true;

                if (req) {
                    b24IpValid = ipAdressValid($('input[name="client_server"]').val()) && !isPrivateIP($('input[name="client_server"]').val());
                    b24DomainValid = domainAdressValid($('input[name="client_server"]').val());
                    if (b24IpValid) {
                        console.log('ok ip');
                    } else if (b24DomainValid) {
                        console.log('ok domain');
                    } else {
                        warnInvalid($('input[name="client_server"]'));
                        return false;
                    }
                }

                if (req) {
                    fpbxIpValid = ipAdressValid($('input[name="ext_address"]').val());
                    fpbxDomainValid = domainAdressValid($('input[name="ext_address"]').val());
                    if (fpbxIpValid) {
                        console.log('ok ip');
                    } else if (fpbxDomainValid) {
                        console.log('ok domain');
                    } else {
                        warnInvalid($('input[name="ext_address"]'));
                        return false;
                    }
                }

                return req;
                //#END_JS_1
            },
            /**
             * Действия на кнопку регистрации при попытке
             * регистрации урла
             * @private
             */
            __lockRegisterButton: function() {
                $(s.settings.buttons.register).attr('disabled', 'disabled');
            },

            /**
             * Рисуем список пользователей полученных из портала б24
             * @param { } responce 
             */
            __renderPortalUsersBlock: function(header, responce, block) {
                var $block = $(block);
                console.log('getUserOnPortal', responce);
                //console.log('responce.users.length', responce.users.length);
                if(typeof responce.users != "undefined" && responce.users.length > 0) {
                    
                    var $template = header;
                    
                    for (var i in responce.users) {
                        
                        if(responce.users[i]['LAST_NAME'] != "" || responce.users[i]['NAME'] != "") {
                            
                            $template += '<option value='+responce.users[i]['ID']+'>'+responce.users[i]['LAST_NAME']+' '+responce.users[i]['NAME']+'</option>';
                        }
                    }
                    $template += '</select>';
                    
                    $block.html($template);
                } else {
                    $block.html(responce.error);
                }
            },

            __checkActives: function() {
                var se = this;
                if (!$('label[for="activatedyes"]').length) {
                    console.log('active');
                    $('li[data-name="settings"]').removeClass('active');
                    $('#settings').removeClass('active');
                    $('li[data-name="inbound_destinations"]').addClass('active');
                    $('#inbound_destinations').addClass('active');
                
                    $('[data-placement="source-options"] select').hide();

                    //проверим доступность портала b24 
                    var promise = $.ajax({
                        url: window.ajaxurl,
                        type: "POST",
                        data: {
                            command: 'checkAviableSite',
                            module: window.modulename,
                            url: this.getClientServerWhenRegister()
                        }
                    });
                    promise.then(function(data) {
                        
                        if(data.message != 'unknown') {
                            $('#page_body .container-fluid').before(data.message);
                        }
                        return $.ajax({
                            url: window.ajaxurl,
                            type: "POST",
                            data: {
                                command: 'getUserOnPortal',
                                module: window.modulename,
                            }
                        });
                    }).then(function(data){
                        
                        var responce = JSON.parse(data.message);
                        se.__renderPortalUsersBlock('<select name="user_id" class="form-control user_id">', responce, '[data-placement="users-from-portal"]');
                        se.__renderPortalUsersBlock('<select name="observers[]" class="form-control tasks_observers">', responce, '[data-observ="observers-list"]');
                        se.__renderPortalUsersBlock('<select name="numbers[]" class="form-control numbers_observers">', responce, '[data-observ="numbers-list"]');
                        
                        $('.user_id').selectize();
                        $('.tasks_observers').selectize();
                        $('.numbers_observers').selectize();

                        return $.ajax({
                            url: window.ajaxurl,
                            type: "POST",
                            data: {
                                command: 'isEventRegister',
                                module: window.modulename,
                            }
                        });
                    }).then(function(data){
                        var events = JSON.parse(data.message);
                        $('[data-placement="isRegisterCall"]').html(events['isRegisterCall']);
                        $('[data-placement="isRegisterCallback"]').html(events['isRegisterCallback']);

                        return $.ajax({
                            url: window.ajaxurl,
                            type: "POST",
                            data: {
                                command: 'getSoucesList',
                                module: window.modulename,
                            }
                        });
                    }).then(function(data) {
                        var sources = data.message;
                        $('[data-placement="source-options"] #floatBarsG').remove();
                        $('[data-placement="source-options"] select').html(sources).show();
                        $('[data-placement="source-options"] select').selectize();

                        return $.ajax({
                            url: window.ajaxurl,
                            type: "POST",
                            data: {
                                command: 'getInfoModule',
                                module: window.modulename,
                                client_server: $('select[name="portal_protocol"]').val() + "://" + $('input[name="client_server"]').val() + ':' + $('input[name="client_server_port"]').val(),
                                ext_address: $('select[name="fpbx_protocol"]').val() + "://" + $('input[name="ext_address"]').val() + ':' + $('input[name="ext_address_port"]').val(),

                            }
                        });

                    }).then(function(data){
                        console.log('getInfoModule', data);
                        if(typeof data['error'] != "undefined") {
                            fpbxToast(data['error'], '', 'warning');
                        } else {
                            $('#extensions_count').text(data['users']);
                            $('#status_pay_b24').text(data['description']);
                            $('#active_before').text(data['workdate']);
                        }
                        
                    }, function(err){
                        console.error(err);
                    });
                    
                }
            },

            removeEvent: function(evt, handler) {
                var removed = $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'unbindCallBackEvent',
                        module: window.modulename,
                        'event': evt,
                        'handler': handler
                    }
                });

                return removed;
            },

            determineRegion: function (detReg) {
                console.log(detReg);
                fpbxToast('Processing', '', 'info');
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'determine_region',
                        module: window.modulename,
                        detReg: detReg
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Determine the region', 'success');
                        document.location.reload();
                    }
                });
            }
        };

    ModuleIUB24.init();

    function timeConverter(UNIX_timestamp) {
        var a = new Date(UNIX_timestamp * 1000);
        var months = ['Января', 'Февраля', 'Марта', 'Апреля', 'Мая', 'Июня', 'Июля', 'Августа', 'Сентября', 'Октября', 'Ноября', 'Декабря'];
        var year = a.getFullYear();
        var month = months[a.getMonth()];
        var date = a.getDate();
        var hour = a.getHours();
        var min = a.getMinutes();
        var sec = a.getSeconds();
        var time = date + ' ' + month + ' ' + year + ' ' + hour + ':' + min + ':' + sec;
        return time;
    }

    function ipAdressValid(ipaddress) {
        if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(ipaddress)) {
            return (true);
        }
        return (false);
    }

    function domainAdressValid(domain) {
        return /^(www\.)?[a-z0-9\-\.]{3,}\.[a-z]{2,}$/.test(domain);
    }
    
    function isPrivateIP(ip) {
       var parts = ip.split('.');
       return parts[0] === '10' || 
          (parts[0] === '172' && (parseInt(parts[1], 10) >= 16 && parseInt(parts[1], 10) <= 31)) || 
          (parts[0] === '192' && parts[1] === '168');
    }
});