$(document).ready(function() {

    var l,

        LinesTab = {
        settings: {
            buttons: {
                add: '#lines_add_button',
                edit: '.iu_lines_edit',
                remove: '.iu_lines_delete'
            }
        },

        init: function () {
            l = this;
            this.bindUIActions();
            this.hideShowTab();
        },

        /**
         * обработчики кнопок
         */
        bindUIActions: function() {
            $(document.body).on('click', l.settings.buttons.add, function() {
                var buttons = [];
                buttons['Submit'] = iub24.lang[currentLocale]['Submit'];
                buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                var buttonArray = {};
                buttonArray[buttons['Submit']] = function() {
                    if(l.__checkInvalid($('#add_lines'))) {
                        l.create();
                        $(this).dialog("close");
                    }
                };
                buttonArray[buttons['Cancel']] = function() {
                    $(this).dialog('close');
                };
                $("#add_lines").dialog({
                    resizable: false,
                    height: "auto",
                    width: 800,
                    modal: true,
                    buttons: buttonArray
                });

            });

            $(document.body).on('click', l.settings.buttons.edit, function() {
                var self = this;
                var $id = $(self).attr('data-line-id');
                var $editDialog = $('#update_lines');
                var promise = l.detail($id);

                promise.done(function(res) {
                    console.log('detail ', res);
                    $editDialog.find('.update_line_form').attr('data-line-id', res.id);
                    $editDialog.find('input[name=did]').val(res.did);
                    $editDialog.find('input[name=number]').val(res.number);
                    var buttons = [];
                    buttons['Update'] = iub24.lang[currentLocale]['Update'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Update']] = function() {
                        if(l.__checkInvalid($('#update_lines'))) {
                            l.update();
                            $(this).dialog("close");
                        }
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };
                    $('#update_lines').dialog({
                        resizable: false,
                        height: "auto",
                        width: 900,
                        modal: true,
                        buttons: buttonArray
                    });
                });

            });

            $(document.body).on('click', l.settings.buttons.remove, function() {
                var self = this;
                var buttons = [];
                buttons['Remove'] = iub24.lang[currentLocale]['Remove'];
                buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                var buttonArray = {};
                buttonArray[buttons['Remove']] = function() {
                    l.remove(self);
                    $(this).dialog("close");
                };
                buttonArray[buttons['Cancel']] = function() {
                    $(this).dialog('close');
                };
                $("#delete_line").dialog({
                    resizable: false,
                    height: "auto",
                    width: 600,
                    modal: true,
                    buttons: buttonArray
                });
            });

        },

            /**
             * создание новой линии
             */
            create: function() {
                var self = this;
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'create_lines_item',
                        module: window.modulename,
                        did: $('#add_lines').find('input[name=did]').val(),
                        number: $('#add_lines').find('input[name=number]').val()
                    },
                    success: function (data) {
                        fpbxToast('Complete', 'Created new line', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * обновление линии
             */
            update: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'update_lines_item',
                        module: window.modulename,
                        id: $('#update_lines').find('.update_line_form').attr('data-line-id'),
                        did: $('#update_lines').find('input[name=did]').val(),
                        number: $('#update_lines').find('input[name=number]').val()
                    },
                    success: function (data) {
                        fpbxToast('Complete', 'Update line', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * удаление линии
             * @param ob
             */
            remove: function(ob) {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'remove_lines_item',
                        module: window.modulename,
                        id: $(ob).attr('data-line-id'),
                        number: $(ob).attr('data-line-number'),
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Remove line', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * получение детальной информации о линии по его id
             * @param id
             * @returns {*}
             */
            detail: function(id) {
                var self = this;
                var deferred = $.Deferred();
                var line = null;

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'get_lines_item',
                        module: window.modulename,
                        id: id
                    },
                    success: function(data) {
                        console.log(data);
                        line = data;
                    },
                    complete: function() {
                        deferred.resolve(line);
                    }
                });

                return deferred.promise();
            },

            hideShowTab: function() {
                if ($('label[for=activatedyes]').length) {
                    $('li[data-name=lines_tab]').hide();
                }
            },
            __checkInvalid: function($form) {
                var did = $form.find('input[name="did"]');
                var number = $form.find('input[name="number"]');
                if(!did.val()){
                    warnInvalid(did);
                    return false;
                }
                if(!number.val()){
                    warnInvalid(number);
                    return false;
                }

                return true;
            },
    };

    LinesTab.init();
});