$(document).ready(function() {

    var outbound,
        OutboundRoutesTab = {
            settings: {
                buttons: {
                    edit: '.iu_outbound_edit',
                    remove: '.iu_outbound_delete',
                    showAdvancedSettings: '.showNumberModify'
                }
            },

            init: function() {
                outbound = this;
                this.bindUIActions();
                this.hideShowTab();
            },

            bindUIActions: function() {

                $(document.body).on('click', outbound.settings.buttons.showAdvancedSettings, function() {
                    $('#update_outbound').find('.showNumberModifyInput').toggle();
                });

                $(document.body).on('click', outbound.settings.buttons.edit, function() {
                    var self = this;
                    var $id = $(self).attr('data-did-id');
                    //var $dialog = $( "#add_outbound" ).clone();
                    var $editDialog = $('#update_outbound');
                    //$editDialog.empty();
                    //$editDialog.html($dialog);

                    var promise = outbound.detail($id);
                    promise.done(function(res) {
                        console.log('detail ', res);
                        $editDialog.find('.update_did_form').attr('data-did-id', res.route_id);
                        $editDialog.find('input[name=description]').val(res.name);
                        $editDialog.find('input[name=create_lead][value=' + res.create_lead + ']').prop('checked', true);
                        $editDialog.find('input[name=show_card_route][value=' + res.show_card + ']').prop('checked', true);
                        $editDialog.find('select[name=source_route]').val(res.source);
                        $editDialog.find('select[name=exclusions]').val(res.exception);

                        if (res.modify_number) {
                            $editDialog.find('input[name=modify_number_first]').val(res.modify_number);
                        } else {
                            $editDialog.find('input[name=modify_number_first]').val('${EXTEN}');
                        }

                        if (res.intracompany_route == 'YES') {
                            $editDialog.find('input[name=status_mode][value=intracompany]').prop('checked', true);
                        } else {
                            switch (res.enable_b24) {
                                case 'no':
                                    $editDialog.find('input[name=status_mode][value=no]').prop('checked', true);
                                    break;
                                case 'yes':
                                    $editDialog.find('input[name=status_mode][value=yes]').prop('checked', true);
                                    break;
                                case 'voting':

                                    $editDialog.find('.show_div_greet').show();
                                    if (res.greatings) {
                                        $editDialog.find('select[name=greatings]').val(res.greatings);
                                    }

                                    $editDialog.find('.show_div_bye').show();
                                    if (res.bye) {
                                        $editDialog.find('select[name=bye]').val(res.bye);
                                    }


                                    $editDialog.find('input[name=status_mode][value=voting]').prop('checked', true);
                                    break;
                                default:
                                    $editDialog.find('input[name=status_mode][value=no]').prop('checked', true);
                            }
                        }
                        var buttons = [];
                        buttons['Update'] = iub24.lang[currentLocale]['Update'];
                        buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                        var buttonArray = {};
                        buttonArray[buttons['Update']] = function() {
                            if(outbound.__checkInvalid()) {
                                outbound.update();
                                $(this).dialog("close");
                            }
                        };
                        buttonArray[buttons['Cancel']] = function() {
                            $(this).dialog('close');
                        };

                        $("#update_outbound").dialog({
                            resizable: false,
                            height: "auto",
                            width: 900,
                            modal: true,
                            buttons: buttonArray
                        });
                    });

                });

                $(document.body).on('click', outbound.settings.buttons.remove, function() {
                    var self = this;
                    var buttons = [];
                    buttons['Remove'] = iub24.lang[currentLocale]['Remove'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Remove']] = function() {
                        outbound.remove(self);
                        $(this).dialog("close");
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };

                    $("#delete_outbound").dialog({
                        resizable: false,
                        height: "auto",
                        width: 600,
                        modal: true,
                        buttons: buttonArray
                    });
                });

                $('#add_outbound input[name=status_mode], ' +
                    '#update_outbound input[name=status_mode]').change(function() {

                    // var $form = $(this).closest('.dialog-form-module');
                    // console.log($(this).val());
                    switch ($(this).val()) {
                        case 'voting':
                            $('.show_div_greet').show();
                            $('.show_div_bye').show();
                            break;
                        default:
                            $('.show_div_greet').hide();
                            $('.show_div_bye').hide();
                            break;
                    }
                });

            },

            update: function() {

                    $.ajax({
                        url: window.ajaxurl,
                        type: "POST",
                        data: {
                            command: 'update_outbound_route',
                            module: window.modulename,
                            id: $('#update_outbound').find('.update_did_form').attr('data-did-id'),
                            name: $('#update_outbound').find('input[name=description]').val(),
                            status: $('#update_outbound').find('input[name=status_mode]:checked').val(),
                            great: $('#update_outbound').find('#greatings').val(),
                            bye: $('#update_outbound').find('#bye').val(),
                            create_lead: $('#update_outbound').find('input[name=create_lead]:checked').val(),
                            show_card: $('#update_outbound').find('input[name=show_card_route]:checked').val(),
                            source: $('#update_outbound').find('#source_route').val(),
                            exception: $('#update_outbound').find('select[name=exclusions]').val(),
                            modify_number: $('#update_outbound').find('input[name=modify_number_first]').val(),
                        },
                        success: function (data) {
                            fpbxToast('Complete', 'Update Outbound Route', 'success');
                            document.location.reload();

                        }
                    });
            },

            remove: function(ob) {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'remove_outbound_route',
                        module: window.modulename,
                        id: $(ob).attr('data-did-id')
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Removing did', 'success');
                        document.location.reload();
                    }
                });
            },

            detail: function(id) {
                var deferred = $.Deferred();
                var route = null;

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'get_outbound_route',
                        module: window.modulename,
                        id: id
                    },
                    success: function(data) {
                        console.log(data);
                        route = data;
                    },
                    complete: function() {
                        deferred.resolve(route);
                    }
                });

                return deferred.promise();
            },

            clearForm: function() {
                $('#add_outbound').find('input[name=description]').val('');
            },

            hideShowTab: function() {
                if ($('label[for=activatedyes]').length) {
                    $('li[data-name=outbound_routes]').hide();
                }
            },
            __checkInvalid: function() {
                var create_lead = $('#update_outbound').find('input[name="create_lead"]');
                var show_card_route = $('#update_outbound').find('input[name="show_card_route"]');
                if (!create_lead.is(':checked')){
                    warnInvalid(create_lead);
                    return false;
                }
                if (!show_card_route.is(':checked')){
                    warnInvalid(show_card_route);
                    return false;
                }
                return (show_card_route.is(':checked') && create_lead.is(':checked'));
            },

        };

    OutboundRoutesTab.init();

});