$(document).ready(function() {

    $('.tasks_observers').selectize({
        create: true,
        sortField: 'text'
    });

    var t,

        LinesTab = {
            settings: {
                buttons: {
                    add: '#task_add_button',
                    edit: '.iu_task_edit',
                    remove: '.iu_task_delete',
                    add_observer: '#add_observers_button',
                    observer_update: '#observers_update_button',
                    observer_del: 'button[data-bind="del-obs"].iu-icon-delete-user',
                    observer_del_update: "button.iu-icon-delete-user-update"
                },
                observer_title: "",
                observer_title_update: "",
                observer_data_id: ""
            },

            init: function () {
                t = this;
                this.bindUIActions();
                this.hideShowTab();
                t.settings.observer_title = $("#add_task").find("label[data-name='observers']").text();
                console.log("t.settings.observer_title_update", t.settings.observer_title_update);
            },

            /**
             * обработчики кнопок
             */
            bindUIActions: function() {
                $(document.body).on('click', t.settings.buttons.add, function() {
                    var buttons = [];
                    console.log(iub24);
                    buttons['Submit'] = iub24.lang[currentLocale]['Submit'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Submit']] = function() {
                        t.create();
                        $(this).dialog("close");
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };
                    $("#add_task").dialog({
                        resizable: false,
                        height: "auto",
                        width: 800,
                        modal: true,
                        buttons: buttonArray
                    });

                });

                /**
                 * Добавление наблюдателей при добавлении задачи
                 */
                $(document.body).on('click', t.settings.buttons.add_observer, function() {

                    $('.tasks_observers').each(function(){ // do this for every select with the 'combobox' class
                        if ($(this)[0].selectize) { // requires [0] to select the proper object
                            var value = $(this).val(); // store the current value of the select/input
                            $(this)[0].selectize.destroy(); // destroys selectize()
                            $(this).val(value);  // set back the value of the select/input
                        }
                    });

                    $('#add_observers').before('<div class="col-md-3"><button type="button" data-bind="del-obs" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user margin-style-delete" role="button">' +
                        '<span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>' +
                        '</button></div><div class="col-md-9" data-observ="observers-list">' +
                        $('div[data-observ="observers-list"]:first').clone().html() +
                        '</div>');

                    $('button[data-bind="del-obs"].iu-icon-delete-user').removeClass("hidden");

                    $('.tasks_observers').selectize({
                        create: true,
                        sortField: 'text'
                    });
                });

                /**
                 * Удаление наблюдателей при добавлении задачи
                 */
                $(document.body).on('click', t.settings.buttons.observer_del, function() {
                    var self = this;
                    
                    if ($("#add_task").find(".col-md-9[data-observ='observers-list']").length > 1) {

                        $(self).closest(".col-md-3").next().remove();
                        $(self).parent().remove();

                        var observTitle = $("#add_task").find("label[data-name='observers']").text();

                        if (observTitle.length < 1) {
                            $('div[data-observ="observers-list"]:first').prev().prepend('<label class="control-label" for="observers" data-name="observers">' +
                                t.settings.observer_title +
                                '</label>');
                            $('div[data-observ="observers-list"]:first').prev().find('button[data-bind="del-obs"].iu-icon-delete-user')
                                .removeClass("margin-style-delete").addClass("margin-style-delete-main");
                        }
                    }

                    if ($("#add_task").find(".col-md-9[data-observ='observers-list']").length == 1) {
                        $('button[data-bind="del-obs"].iu-icon-delete-user').addClass("hidden");
                    }
                });

                $(document.body).on('click', t.settings.buttons.edit, function() {
                    var self = this;
                    var $id = $(self).attr('data-task-id');
                    var $editDialog = $('#update_task');
                    $editDialog.find('div[data-clear="observ-clear"]').remove();
                    $editDialog.find('div[data-observ="observers-update-add"]').remove();
                    var promise = t.detail($id);

                    promise.done(function(res) {
                        $editDialog.find('.update_task_form').attr('data-task-id', res.id);
                        $editDialog.find('input[name=task_name]').val(res.name);
                        $editDialog.find('input[name=deadline]').val(res.deadline);
                        $editDialog.find('select[name=hour_day]').val(res.deadline_day);
                        $editDialog.find('div[data-name="update_observ"]').prepend(res.observers);
                        t.settings.observer_title_update = $editDialog.find("label[data-name='observers_update']").text();
                        t.settings.observer_data_id = [];
                        var data_id = [];

                        var $selectize = $('.update_observers').selectize({
                            create: true,
                            sortField: 'text'
                        });
                        var buttons = [];
                        buttons['Update'] = iub24.lang[currentLocale]['Update'];
                        buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                        var buttonArray = {};
                        buttonArray[buttons['Update']] = function() {
                            t.update();
                            $(this).dialog("close");
                        };
                        buttonArray[buttons['Cancel']] = function() {
                            $(this).dialog('close');
                        };

                        $('.update_observers').each(function(){
                            if ($(this).attr('data-id')) {
                                data_id.push($(this).attr('data-id'));
                            }
                        });

                        t.settings.observer_data_id = data_id;

                        $('#update_task').dialog({
                            resizable: false,
                            height: "auto",
                            width: 900,
                            modal: true,
                            buttons: buttonArray
                        });
                    });

                });

                /**
                 * Добавление наблюдателей при изменении задачи
                 */
                $(document.body).on('click', t.settings.buttons.observer_update, function() {

                    var addUp = $(this).closest("div.form-group").find("div.obs_update");
                    var self = $(this);

                    $(this).closest("div.form-group").find("select.update_observers").each(function(){ // do this for every select with the 'combobox' class
                        if ($(this)[0].selectize) { // requires [0] to select the proper object
                            var value = $(this).val(); // store the current value of the select/input
                            $(this)[0].selectize.destroy(); // destroys selectize()
                            $(this).val(value);  // set back the value of the select/input
                        }
                    });

                    addUp.before('<div class="col-md-3" data-observ="observers-update-add">' +
                        '<button type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user-update margin-style-delete" role="button">' +
                        '<span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>' +
                        '</button></div><div class="col-md-9" data-observ="observers-update-add">' +
                        $('.col-md-9[data-observ="observers-update-add"]:first').clone().html() +
                        '</div>');

                    $("button.iu-icon-delete-user-update").removeClass("hidden");

                    $(this).closest("div.form-group").find("select.update_observers").selectize({
                        create: true,
                        sortField: 'text'
                    });
                });

                /**
                 * Удаление наблюдателей при изменении задачи
                 */
                $(document.body).on('click', t.settings.buttons.observer_del_update, function() {
                    var self = this;

                    if ($("#update_task").find(".col-md-9[data-observ='observers-update-add']").length > 1) {
                        
                        $(self).closest(".col-md-3").next().remove();
                        $(self).parent().remove();

                        var observTitle = $("#update_task").find("label[data-name='observers_update']").text();

                        if (observTitle.length < 1) {
                            $('.col-md-9[data-observ="observers-update-add"]:first').prev().prepend('<label class="control-label" for="observers" data-name="observers_update">' +
                                t.settings.observer_title_update +
                                '</label>');
                            $('.col-md-9[data-observ="observers-update-add"]:first').prev().find("button.iu-icon-delete-user-update")
                                .removeClass("margin-style-delete").addClass("margin-style-delete-main");
                        }
                    }

                    if ($("#update_task").find(".col-md-9[data-observ='observers-update-add']").length == 1) {
                        $("button.iu-icon-delete-user-update").addClass("hidden");
                    }
                });

                $(document.body).on('click', t.settings.buttons.remove, function() {
                    var self = this;
                    var buttons = [];
                    buttons['Remove'] = iub24.lang[currentLocale]['Remove'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Remove']] = function() {
                        t.remove(self);
                        $(this).dialog("close");
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };
                    $("#delete_task").dialog({
                        resizable: false,
                        height: "auto",
                        width: 600,
                        modal: true,
                        buttons: buttonArray
                    });
                });

            },

            /**
             * создание новой задачи
             */
            create: function() {
                var self = this;
                var observers = [];

                $('.tasks_observers').each(function(){
                    if ($(this).val() != 0) {
                        observers.push($(this).val());
                    }
                });

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'create_task_item',
                        module: window.modulename,
                        name: $('#add_task').find('input[name=task_name]').val(),
                        observers: JSON.stringify(observers),
                        deadline: $('#add_task').find('input[name=deadline]').val(),
                        deadline_day: $('#add_task').find('select[name=hour_day]').val()
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Created new task', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * изменение задачи
             */
            update: function() {

                var observers = [];

                $('.update_observers').each(function(){
                    if ($(this).val() != 0) {
                        observers.push($(this).val());
                    }
                });

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'update_task_item',
                        module: window.modulename,
                        id: $('#update_task').find('.update_task_form').attr('data-task-id'),
                        name: $('#update_task').find('input[name=task_name]').val(),
                        deadline: $('#update_task').find('input[name=deadline]').val(),
                        deadline_day: $('#update_task').find('select[name=hour_day]').val(),
                        observers: JSON.stringify(observers),
                        observersID: JSON.stringify(t.settings.observer_data_id)
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Update task', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * удаление задачи
             * @param ob
             */
            remove: function(ob) {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'remove_task_item',
                        module: window.modulename,
                        id: $(ob).attr('data-task-id')
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Remove task', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * получение детальной информации о задаче по ее id
             * @param id
             * @returns {*}
             */
            detail: function(id) {
                var self = this;
                var deferred = $.Deferred();
                var task = null;

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'get_task_item',
                        module: window.modulename,
                        id: id
                    },
                    success: function(data) {
                        task = data;
                    },
                    complete: function() {
                        deferred.resolve(task);
                    }
                });

                return deferred.promise();
            },

            hideShowTab: function() {
                if ($('label[for=activatedyes]').length) {
                    $('li[data-name=tasks]').hide();
                }
            }
        };

    LinesTab.init();
});